Page MenuHomePhabricator

[WebAssembly] Narrowing and widening SIMD ops
ClosedPublic

Authored by tlively on Sep 10 2019, 5:23 PM.

Diff Detail

Repository
rL LLVM

Event Timeline

tlively created this revision.Sep 10 2019, 5:23 PM
Herald added projects: Restricted Project, Restricted Project. · View Herald TranscriptSep 10 2019, 5:23 PM

Can you give the link for the spec of these new instructions?

tlively planned changes to this revision.Sep 10 2019, 8:21 PM

I missed the fact that the narrows are supposed to be binary operations. Oops.

tlively edited the summary of this revision. (Show Details)Sep 11 2019, 1:18 PM
tlively updated this revision to Diff 219784.Sep 11 2019, 1:20 PM
  • Make narrows binary ops
aheejin accepted this revision.Sep 12 2019, 6:16 PM

LGTM.

  • Maybe we can lower these to these new instructions later? (I'm not very sure what the difference between versions with and without VECTOR, because the versions without VECTOR seem to be able to take vector arguments as well.)
  • Will this simplify the complicated lowering of SIGN_EXTEND_INREG?
This revision is now accepted and ready to land.Sep 12 2019, 6:16 PM

LGTM.

  • Maybe we can lower these to these new instructions later? (I'm not very sure what the difference between versions with and without VECTOR, because the versions without VECTOR seem to be able to take vector arguments as well.)
  • Will this simplify the complicated lowering of SIGN_EXTEND_INREG?

Yes, good points. I will make a note to go back and clean these up once we are able to emit these instructions without explicit user opt-in.

This revision was automatically updated to reflect the committed changes.